#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20130304

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)


#ifndef yyparse
#define yyparse    rcsparse
#endif /* yyparse */

#ifndef yylex
#define yylex      rcslex
#endif /* yylex */

#ifndef yyerror
#define yyerror    rcserror
#endif /* yyerror */

#ifndef yychar
#define yychar     rcschar
#endif /* yychar */

#ifndef yyval
#define yyval      rcsval
#endif /* yyval */

#ifndef yylval
#define yylval     rcslval
#endif /* yylval */

#ifndef yydebug
#define yydebug    rcsdebug
#endif /* yydebug */

#ifndef yynerrs
#define yynerrs    rcsnerrs
#endif /* yynerrs */

#ifndef yyerrflag
#define yyerrflag  rcserrflag
#endif /* yyerrflag */

#ifndef yylhs
#define yylhs      rcslhs
#endif /* yylhs */

#ifndef yylen
#define yylen      rcslen
#endif /* yylen */

#ifndef yydefred
#define yydefred   rcsdefred
#endif /* yydefred */

#ifndef yydgoto
#define yydgoto    rcsdgoto
#endif /* yydgoto */

#ifndef yysindex
#define yysindex   rcssindex
#endif /* yysindex */

#ifndef yyrindex
#define yyrindex   rcsrindex
#endif /* yyrindex */

#ifndef yygindex
#define yygindex   rcsgindex
#endif /* yygindex */

#ifndef yytable
#define yytable    rcstable
#endif /* yytable */

#ifndef yycheck
#define yycheck    rcscheck
#endif /* yycheck */

#ifndef yyname
#define yyname     rcsname
#endif /* yyname */

#ifndef yyrule
#define yyrule     rcsrule
#endif /* yyrule */
#define YYPREFIX "rcs"

#define YYPURE 0

#line 23 "rcsy.y"
#define YYERROR_VERBOSE	1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <gd.h>		/* For gdFontPtr in cvsgraph.h */
#include "cvsgraph.h"
#include "utils.h"
#include "rcs.h"

rcsfile_t *rcsfile;

static tag_t *new_tag(char *s, char *r);
static tags_t *new_tags(tag_t *s);
static tags_t *add_tags(tags_t *s, tag_t *t);
static idrev_t *new_idrev(char *s, char *r);
static idrevs_t *new_idrevs(idrev_t *s);
static idrevs_t *add_idrevs(idrevs_t *s, idrev_t *t);
static ids_t *new_ids(char *s);
static ids_t *add_ids(ids_t *s, char *t);
static revs_t *new_revs(char *s);
static revs_t *add_revs(revs_t *s, char *t);
static dtext_t *new_dtext(char *n, char *l, char *t);
static dtexts_t *add_dtexts(dtexts_t *s, dtext_t *t);
static phrase_t *new_phrase(phrase_type_e pt, char *t);
static phrases_t *add_phrases(phrases_t *s, phrase_t *t);
static phrases_t *merge_phrases(phrases_t *s, phrases_t *t);
static delta_t *new_delta(char *rev, char *date, char *author, char *state, revs_t *branches, char *next, phrases_t *phrases);
static deltas_t *add_deltas(deltas_t *s, delta_t *t);
static rcsfile_t *new_rcsfile(char *head, char *branch, ids_t *access, tags_t *tags,
				idrevs_t *locks, int strict, char *comment, char *expand);

#line 59 "rcsy.y"
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union{
	int		i;
	char		*str;
	tag_t		*tag;
	tags_t		*tags;
	idrev_t		*idrev;
	idrevs_t	*idrevs;
	ids_t		*ids;
	revs_t		*revs;
	dtext_t		*dtext;
	dtexts_t	*dtexts;
	delta_t		*delta;
	deltas_t	*deltas;
	rcsfile_t	*rcsfile;
	phrases_t	*phrases;
	phrase_t	*phrase;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 159 "rcs.tab.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define tHEAD 257
#define tBRANCH 258
#define tACCESS 259
#define tSYMBOLS 260
#define tLOCKS 261
#define tSTRICT 262
#define tCOMMENT 263
#define tEXPAND 264
#define tDATE 265
#define tAUTHOR 266
#define tSTATE 267
#define tBRANCHES 268
#define tNEXT 269
#define tDESC 270
#define tLOG 271
#define tTEXT 272
#define tOWNER 273
#define tGROUP 274
#define tPERMISSIONS 275
#define tSPECIAL 276
#define tSYMLINK 277
#define tHARDLINKS 278
#define tNAMESPACE 279
#define tDEAD 280
#define tMERGEPOINT 281
#define tDELTATYPE 282
#define tCOMMITID 283
#define tKOPT 284
#define tFILENAME 285
#define tPROPERTIES 286
#define tNEWPHRASE 287
#define tSTRING 288
#define tREV 289
#define tID 290
#define tSYM 291
#define YYERRCODE 256
static const short rcslhs[] = {                          -1,
   27,    0,   28,   29,   30,   24,   19,   19,    4,    4,
    5,    5,    6,    6,   23,   23,   31,   32,   22,    8,
    8,    7,   21,   21,   33,   20,   25,   25,   34,   26,
   36,   26,   38,   26,   26,   26,   35,   35,   35,   35,
   35,   35,   37,   37,   37,   37,   37,   37,   37,    1,
    1,    2,    2,   18,   18,   17,   17,    3,    3,   16,
   16,   15,   15,   14,   14,   13,   13,   12,   11,   11,
   10,   10,    9,    9,
};
static const short rcslen[] = {                           2,
    0,    5,    0,    0,    0,   20,    0,    2,    0,    3,
    0,    3,    0,    3,    0,    2,    0,    0,   20,    1,
    1,    2,    0,    2,    0,    7,    0,    2,    0,    3,
    0,    3,    0,    3,    3,    3,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,
    1,    0,    1,    0,    1,    1,    2,    0,    1,    0,
    1,    1,    2,    0,    1,    1,    2,    3,    0,    1,
    1,    2,    3,    4,
};
static const short rcsdefred[] = {                        0,
    0,    0,   15,   53,    0,    0,    0,    0,    0,    1,
   16,    0,    0,   22,    0,   23,    0,    3,    0,    0,
   10,    0,    0,    0,   24,   62,    0,    0,   17,    0,
   63,    0,    0,   27,    4,   21,   20,    0,    0,    0,
    0,   25,   37,   38,   39,   40,   41,   42,   43,   44,
    0,   45,   46,   47,   48,   49,   29,   28,   31,   33,
    0,    0,   71,    0,    0,   18,    0,    0,    0,    0,
    0,    0,    0,    0,   72,    0,    0,   26,   35,   36,
   30,   32,   34,   73,    0,    5,   59,    0,   74,    0,
    0,    0,   66,    0,    0,    0,    0,   67,    0,   56,
    0,    0,   68,    0,    0,   57,   27,    8,    0,    0,
    0,   51,    0,    0,   27,    0,   12,    0,    0,    0,
   14,   27,    0,
};
static const short rcsdgoto[] = {                         2,
  113,    5,   88,   13,  110,  115,   10,   38,   63,   64,
   65,   93,   94,   95,   27,   28,  101,  102,  105,   25,
   20,   11,    6,    3,   39,   58,   16,   22,   40,   90,
   33,   77,   67,   70,   59,   71,   60,   72,
};
static const short rcssindex[] = {                     -252,
 -258,    0,    0,    0,  -27, -260, -223, -217, -193,    0,
    0, -258, -152,    0, -183,    0,   49,    0,   50, -179,
    0, -177, -155, -157,    0,    0, -175,   57,    0, -171,
    0, -142, -284,    0,    0,    0,    0,   76, -184,  -58,
 -131,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -281,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   79, -151,    0,  -58,   80,    0, -148,   82,   83,   84,
   85,   86, -143,   89,    0, -113, -141,    0,    0,    0,
    0,    0,    0,    0, -138,    0,    0,   92,    0, -137,
 -116,   96,    0, -137,   97, -134, -132,    0, -104,    0,
 -130,  101,    0,  102, -101,    0,    0,    0, -125, -100,
 -200,    0,  106, -125,    0, -258,    0,  107, -153,  108,
    0,    0, -153,
};
static const short rcsrindex[] = {                        0,
  109,    0,    0,    0,    0,    0,  -90,    0,    0,    0,
    0,  109,    0,    0,    0,    0,    0,    0,    0,  170,
    0,  112,    0,    0,    0,    0,  113,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  114,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  115,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  116,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  117,
    0,    0,    0,  118,    0,  119,    0,    0, -261,    0,
  120,    0,    0,    0, -237,    0,    0,    0,  121, -219,
    0,    0,    0,  121,    0,  109,    0,    0, -259,    0,
    0,    0, -236,
};
static const short rcsgindex[] = {                        0,
   67,  -11,    0,    0,    0,    0,    0,    0,  122,    0,
    0,   88,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   -3,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 233
static const short rcstable[] = {                        62,
   17,    7,    7,   36,    1,   37,   68,   69,    7,    8,
    6,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,   11,    7,    9,    6,
    4,    7,   11,   19,   12,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   13,   11,   19,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,  116,   13,
   14,   15,   43,   44,   45,   46,   47,   48,   49,   50,
   51,   52,   53,   54,   55,   56,   57,   42,   43,   44,
   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
   55,   56,   57,  111,  120,   19,   18,   21,   23,   24,
   29,  119,   26,   30,   31,   32,   34,   35,  123,   43,
   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
   54,   55,   56,   57,   41,   66,   73,   74,   76,   78,
   79,   80,   81,   82,   83,   84,   85,   86,   87,   89,
   91,   96,   92,   97,  100,   99,  103,  104,  106,  107,
  108,  109,  112,  114,  117,  121,  122,   52,    9,    2,
   60,   61,   69,   70,   58,   64,   65,   54,   55,   50,
  118,   98,    0,    0,    0,   75,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   61,
};
static const short rcscheck[] = {                        58,
   12,  263,  264,  288,  257,  290,  288,  289,  270,  270,
  270,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  264,  289,  289,  289,
  289,   59,  270,  270,  258,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  270,  289,  289,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  269,  289,
  288,  265,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  107,  116,  289,  259,   59,   59,  289,
  266,  115,  290,  271,  290,   59,  288,  260,  122,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,   59,  267,   58,  289,   59,  288,
   59,   59,   59,   59,   59,  289,   58,  261,  290,  288,
   59,  268,  290,   58,  289,   59,  289,  262,  289,   59,
   59,  263,  288,  264,   59,   59,   59,   59,  259,    0,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
  114,   94,   -1,   -1,   -1,   64,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  291,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 1
#endif
#define YYMAXTOKEN 291
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"':'","';'",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"tHEAD","tBRANCH",
"tACCESS","tSYMBOLS","tLOCKS","tSTRICT","tCOMMENT","tEXPAND","tDATE","tAUTHOR",
"tSTATE","tBRANCHES","tNEXT","tDESC","tLOG","tTEXT","tOWNER","tGROUP",
"tPERMISSIONS","tSPECIAL","tSYMLINK","tHARDLINKS","tNAMESPACE","tDEAD",
"tMERGEPOINT","tDELTATYPE","tCOMMITID","tKOPT","tFILENAME","tPROPERTIES",
"tNEWPHRASE","tSTRING","tREV","tID","tSYM",
};
static const char *yyrule[] = {
"$accept : rcsfile",
"$$1 :",
"rcsfile : admin deltas desc $$1 dtexts",
"$$2 :",
"$$3 :",
"$$4 :",
"admin : tHEAD orev ';' obranch tACCESS $$2 oids ';' tSYMBOLS $$3 otags ';' tLOCKS $$4 oidrevs ';' ostrict ocomment oexpand ophrases",
"ostrict :",
"ostrict : tSTRICT ';'",
"obranch :",
"obranch : tBRANCH orev ';'",
"ocomment :",
"ocomment : tCOMMENT ostr ';'",
"oexpand :",
"oexpand : tEXPAND ostr ';'",
"deltas :",
"deltas : deltas delta",
"$$5 :",
"$$6 :",
"delta : tREV tDATE tREV ';' tAUTHOR $$5 idorstr ';' tSTATE $$6 oid ';' tBRANCHES orevs ';' ophrases tNEXT orev ';' ophrases",
"idorstr : tID",
"idorstr : tSTRING",
"desc : tDESC tSTRING",
"dtexts :",
"dtexts : dtexts dtext",
"$$7 :",
"dtext : tREV tLOG tSTRING ophrases tTEXT $$7 tSTRING",
"ophrases :",
"ophrases : ophrases phrase",
"$$8 :",
"phrase : tNEWPHRASE $$8 ';'",
"$$9 :",
"phrase : cvskw $$9 ';'",
"$$10 :",
"phrase : otherkw $$10 ';'",
"phrase : tMERGEPOINT tSTRING ';'",
"phrase : tMERGEPOINT tREV ';'",
"cvskw : tOWNER",
"cvskw : tGROUP",
"cvskw : tPERMISSIONS",
"cvskw : tSPECIAL",
"cvskw : tSYMLINK",
"cvskw : tHARDLINKS",
"otherkw : tNAMESPACE",
"otherkw : tDEAD",
"otherkw : tDELTATYPE",
"otherkw : tCOMMITID",
"otherkw : tKOPT",
"otherkw : tFILENAME",
"otherkw : tPROPERTIES",
"ostr :",
"ostr : tSTRING",
"orev :",
"orev : tREV",
"orevs :",
"orevs : revs",
"revs : tREV",
"revs : revs tREV",
"oid :",
"oid : tID",
"oids :",
"oids : ids",
"ids : tID",
"ids : ids tID",
"oidrevs :",
"oidrevs : idrevs",
"idrevs : idrev",
"idrevs : idrevs idrev",
"idrev : tID ':' tREV",
"otags :",
"otags : tags",
"tags : tag",
"tags : tags tag",
"tag : tSYM ':' tREV",
"tag : ':' tREV ':' tSTRING",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 289 "rcsy.y"
static rev_t *make_rev(char *s, int isrev)
{
	char *cptr;
	int dots = 0;
	rev_t *r;

	if(!s)
		return NULL;

	r = xmalloc(sizeof(*r));

	for(cptr = s; *cptr; cptr++)
	{
		if(*cptr == '.')
			dots++;
	}
	if(!dots)
	{
		r->rev = xstrdup("");
		r->branch = xstrdup(s);
		r->isbranch = 1;
	}
	else if(!*s)
	{
		r->rev = xstrdup("?.?");
		r->branch = xstrdup("?");
	}
	else if(dots & 1)
	{
		char *t;
		r->rev = s;
		r->branch = xstrdup(s);
		cptr = strrchr(r->branch, '.');
		assert(cptr != NULL);
		*cptr = '\0';
		t = strrchr(r->branch, '.');
		if(!isrev && ((t && !strcmp(t+1, "0")) || (!t && !strcmp(r->branch, "0"))))
		{
			/* Magic branch numbers "x.x.0.x" */
			r->isbranch = 1;
			if(t)
				strcpy(t+1, cptr+1);
			else
				strcpy(r->branch, cptr+1);
		}
	}
	else
	{
		r->isbranch = 1;
		r->branch = s;
		r->rev = xmalloc(strlen(s) + 3);
		strcpy(r->rev, s);
		strcat(r->rev, ".?");
	}
	return r;
}


static tag_t *new_tag(char *s, char *r)
{
	tag_t *t = xmalloc(sizeof(*t));
	t->tag = s;
	t->rev = make_rev(r, 0);
	return t;
}

static tags_t *new_tags(tag_t *s)
{
	tags_t *t = xmalloc(sizeof(*t));
	t->ntags = 1;
	t->tags = xmalloc(sizeof(t->tags[0]));
	t->tags[0] = s;
	return t;
}

static tags_t *add_tags(tags_t *s, tag_t *t)
{
	if(!s)
		return new_tags(t);
	s->tags = xrealloc(s->tags, (s->ntags+1) * sizeof(s->tags[0]));
	s->tags[s->ntags] = t;
	s->ntags++;
	return s;
}

static idrev_t *new_idrev(char *s, char *r)
{
	idrev_t *t = xmalloc(sizeof(*t));
	t->id = s;
	t->rev = make_rev(r, 1);
	return t;
}

static idrevs_t *new_idrevs(idrev_t *s)
{
	idrevs_t *t = xmalloc(sizeof(*t));
	t->nidrevs = 1;
	t->idrevs = xmalloc(sizeof(t->idrevs[0]));
	t->idrevs[0] = s;
	return t;
}

static idrevs_t *add_idrevs(idrevs_t *s, idrev_t *t)
{
	if(!s)
		return new_idrevs(t);
	s->idrevs = xrealloc(s->idrevs, (s->nidrevs+1) * sizeof(s->idrevs[0]));
	s->idrevs[s->nidrevs] = t;
	s->nidrevs++;
	return s;
}

static ids_t *new_ids(char *s)
{
	ids_t *t = xmalloc(sizeof(*t));
	t->nids = 1;
	t->ids = xmalloc(sizeof(t->ids[0]));
	t->ids[0] = s;
	return t;
}

static ids_t *add_ids(ids_t *s, char *t)
{
	s->ids = xrealloc(s->ids, (s->nids+1) * sizeof(s->ids[0]));
	s->ids[s->nids] = t;
	s->nids++;
	return s;
}

static revs_t *new_revs(char *s)
{
	revs_t *t = xmalloc(sizeof(*t));
	t->nrevs = 1;
	t->revs = xmalloc(sizeof(t->revs[0]));
	t->revs[0] = make_rev(s, 1);
	return t;
}

static revs_t *add_revs(revs_t *s, char *t)
{
	s->revs = xrealloc(s->revs, (s->nrevs+1) * sizeof(s->revs[0]));
	s->revs[s->nrevs] = make_rev(t, 1);
	s->nrevs++;
	return s;
}

static dtext_t *new_dtext(char *n, char *l, char *t)
{
	dtext_t *d = xmalloc(sizeof(*d));
	d->rev = make_rev(n, 1);
	d->log = l;
	d->text = t;
	return d;
}

static dtexts_t *add_dtexts(dtexts_t *s, dtext_t *t)
{
	if(!s)
		s = xmalloc(sizeof(*s));
	s->dtexts = xrealloc(s->dtexts, (s->ndtexts+1) * sizeof(s->dtexts[0]));
	s->dtexts[s->ndtexts] = t;
	s->ndtexts++;
	return s;
}

static phrase_t *new_phrase(phrase_type_e pt, char *t)
{
	phrase_t *d = xmalloc(sizeof(*d));
	d->type = pt;
	d->rev = make_rev(t, 1);
	return d;
}
	
static phrases_t *add_phrases(phrases_t *s, phrase_t *t)
{
	if(!t)
		return s;
	if(!s)
		s = xmalloc(sizeof(*s));
	if(t)
	{
		s->phrases = xrealloc(s->phrases, (s->nphrases + 1) * sizeof(s->phrases[0]));
		s->phrases[s->nphrases] = t;
		s->nphrases++;
	}
	return s;
}

static phrases_t *merge_phrases(phrases_t *s, phrases_t *t)
{
	if(!t)
		return s;
	if(!s)
		return t;
	s->phrases = xrealloc(s->phrases, (s->nphrases + t->nphrases) * sizeof(s->phrases[0]));
	memcpy(&s->phrases[s->nphrases], &t->phrases[0], t->nphrases * sizeof(t->phrases[0]));
	s->nphrases += t->nphrases;
	/* FIXME: Free t and content; hm, who cares... */
	return s;
}

static phrase_t *find_mergepoint(phrases_t *p)
{
	int i;

	if(!p)
		return NULL;

	for(i = 0; i < p->nphrases; i++)
	{
		if(p->phrases[i]->type == PT_MERGEPOINT)
			return p->phrases[i];
	}
	return NULL;
}

static delta_t *new_delta(char *rev, char *date, char *author, char *state, revs_t *branches, char *next, phrases_t *phrases)
{
	delta_t *d = xmalloc(sizeof(*d));
	d->rev = make_rev(rev, 1);
	d->date = date;
	d->author = author;
	d->state = state;
	d->branches = branches;
	d->next = make_rev(next, 1);
	d->phrases = phrases;
	d->mergepoint = find_mergepoint(phrases);
	return d;
}

static deltas_t *add_deltas(deltas_t *s, delta_t *t)
{
	if(!s)
		s = xmalloc(sizeof(*s));
	s->deltas = xrealloc(s->deltas, (s->ndeltas+1) * sizeof(s->deltas[0]));
	s->deltas[s->ndeltas] = t;
	s->ndeltas++;
	return s;
}

static rcsfile_t *new_rcsfile(char *head, char *branch, ids_t *access, tags_t *tags,
				idrevs_t *locks, int strict, char *comment, char *expand)
{
	rcsfile_t *r = xmalloc(sizeof(*r));
	r->head = make_rev(head, 1);
	r->branch = make_rev(branch, 0);
	r->access = access;
	r->tags = tags;
	r->locks = locks;
	r->strict = strict;
	r->comment = comment;
	r->expand = expand;
	return r;
}

#line 748 "rcs.tab.c"

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (short *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 1:
#line 104 "rcsy.y"
	{
		rcsfile = yystack.l_mark[-2].rcsfile;
		rcsfile->deltas = yystack.l_mark[-1].deltas;
		rcsfile->desc = yystack.l_mark[0].str;
		rcsfile->dtexts = NULL;
		if(rcsfile->head)
		{
			char *h = xstrdup("HEAD");
			char *r = xstrdup(rcsfile->head->rev);
			tag_t *t = new_tag(h, r);
			t->ignore = -1;	/* Make sure it doesn't get zapped */
			rcsfile->tags = add_tags(rcsfile->tags, t);
		}
		if(rcsfile->branch)
		{
			char *h = xstrdup("MAIN");
			char *r = xstrdup(rcsfile->branch->rev);
			tag_t *t = new_tag(h, r);
			t->rev->isbranch = 1;
			rcsfile->tags = add_tags(rcsfile->tags, t);
		}
		/* Else we need to add the main tag later because the
		 * trunk is reversed in order and the primary revision
		 * numbers can vary.
		 */
		if(!conf.parse_logs)
		{
			/* Return from the yyparse() call early to avoid parsing
			 * of the possibly extremely large deltatext. This speeds
			 * up parsing of binary files by a very large factor.
			 */
			return 0;
		}
		}
break;
case 2:
#line 140 "rcsy.y"
	{ rcsfile->dtexts = yystack.l_mark[0].dtexts; }
break;
case 3:
#line 145 "rcsy.y"
	{ set_id(); }
break;
case 4:
#line 146 "rcsy.y"
	{ set_sym(); }
break;
case 5:
#line 147 "rcsy.y"
	{ set_id(); }
break;
case 6:
#line 150 "rcsy.y"
	{ yyval.rcsfile = new_rcsfile(yystack.l_mark[-18].str, yystack.l_mark[-16].str, yystack.l_mark[-13].ids, yystack.l_mark[-9].tags, yystack.l_mark[-5].idrevs, yystack.l_mark[-3].i, yystack.l_mark[-2].str, yystack.l_mark[-1].str); }
break;
case 7:
#line 153 "rcsy.y"
	{ yyval.i = 0; }
break;
case 8:
#line 154 "rcsy.y"
	{ yyval.i = 1; }
break;
case 9:
#line 157 "rcsy.y"
	{ yyval.str = NULL; }
break;
case 10:
#line 158 "rcsy.y"
	{ yyval.str = yystack.l_mark[-1].str; }
break;
case 11:
#line 161 "rcsy.y"
	{ yyval.str = NULL; }
break;
case 12:
#line 162 "rcsy.y"
	{ yyval.str = yystack.l_mark[-1].str; }
break;
case 13:
#line 165 "rcsy.y"
	{ yyval.str = NULL; }
break;
case 14:
#line 166 "rcsy.y"
	{ yyval.str = yystack.l_mark[-1].str; }
break;
case 15:
#line 169 "rcsy.y"
	{ yyval.deltas = NULL; }
break;
case 16:
#line 170 "rcsy.y"
	{ yyval.deltas = add_deltas(yystack.l_mark[-1].deltas, yystack.l_mark[0].delta); }
break;
case 17:
#line 175 "rcsy.y"
	{ set_author(); }
break;
case 18:
#line 176 "rcsy.y"
	{ set_id(); }
break;
case 19:
#line 180 "rcsy.y"
	{ yyval.delta = new_delta(yystack.l_mark[-19].str, yystack.l_mark[-17].str, yystack.l_mark[-13].str, yystack.l_mark[-9].str, yystack.l_mark[-6].revs, yystack.l_mark[-2].str, merge_phrases(yystack.l_mark[-4].phrases, yystack.l_mark[0].phrases)); }
break;
case 20:
#line 183 "rcsy.y"
	{ yyval.str = yystack.l_mark[0].str; }
break;
case 21:
#line 184 "rcsy.y"
	{ yyval.str = yystack.l_mark[0].str; }
break;
case 22:
#line 187 "rcsy.y"
	{ yyval.str = yystack.l_mark[0].str; }
break;
case 23:
#line 190 "rcsy.y"
	{ yyval.dtexts = NULL; }
break;
case 24:
#line 191 "rcsy.y"
	{ yyval.dtexts = add_dtexts(yystack.l_mark[-1].dtexts, yystack.l_mark[0].dtext); }
break;
case 25:
#line 197 "rcsy.y"
	{ set_skipstr(); }
break;
case 26:
#line 197 "rcsy.y"
	{ yyval.dtext = new_dtext(yystack.l_mark[-6].str, yystack.l_mark[-4].str, yystack.l_mark[0].str); }
break;
case 27:
#line 200 "rcsy.y"
	{ yyval.phrases = NULL; }
break;
case 28:
#line 201 "rcsy.y"
	{ yyval.phrases = add_phrases(yystack.l_mark[-1].phrases, yystack.l_mark[0].phrase); }
break;
case 29:
#line 204 "rcsy.y"
	{ set_skip(); }
break;
case 30:
#line 204 "rcsy.y"
	{
		yywarning("Unrecognised `newphrase keyword '%s' skipped", yystack.l_mark[-2].str);
		xfree(yystack.l_mark[-2].str);
		yyval.phrase = NULL;
		}
break;
case 31:
#line 209 "rcsy.y"
	{ set_skip(); }
break;
case 32:
#line 209 "rcsy.y"
	{ yyval.phrase = NULL; /* yywarning("CVS extended keyword skipped"); */ }
break;
case 33:
#line 210 "rcsy.y"
	{ set_skip(); }
break;
case 34:
#line 210 "rcsy.y"
	{ yyval.phrase = NULL; /* yywarning("Other extended keyword"); */ }
break;
case 35:
#line 211 "rcsy.y"
	{ yyval.phrase = new_phrase(PT_MERGEPOINT, yystack.l_mark[-1].str); }
break;
case 36:
#line 212 "rcsy.y"
	{ yyval.phrase = new_phrase(PT_MERGEPOINT, yystack.l_mark[-1].str); }
break;
case 50:
#line 232 "rcsy.y"
	{ yyval.str = NULL; }
break;
case 51:
#line 233 "rcsy.y"
	{ yyval.str = yystack.l_mark[0].str; }
break;
case 52:
#line 236 "rcsy.y"
	{ yyval.str = NULL; }
break;
case 53:
#line 237 "rcsy.y"
	{ yyval.str = yystack.l_mark[0].str; }
break;
case 54:
#line 240 "rcsy.y"
	{ yyval.revs = NULL; }
break;
case 55:
#line 241 "rcsy.y"
	{ yyval.revs = yystack.l_mark[0].revs; }
break;
case 56:
#line 244 "rcsy.y"
	{ yyval.revs = new_revs(yystack.l_mark[0].str); }
break;
case 57:
#line 245 "rcsy.y"
	{ yyval.revs = add_revs(yystack.l_mark[-1].revs, yystack.l_mark[0].str); }
break;
case 58:
#line 248 "rcsy.y"
	{ yyval.str = NULL; }
break;
case 59:
#line 249 "rcsy.y"
	{ yyval.str = yystack.l_mark[0].str; }
break;
case 60:
#line 252 "rcsy.y"
	{ yyval.ids = NULL; }
break;
case 61:
#line 253 "rcsy.y"
	{ yyval.ids = yystack.l_mark[0].ids; }
break;
case 62:
#line 256 "rcsy.y"
	{ set_id(); yyval.ids = new_ids(yystack.l_mark[0].str); }
break;
case 63:
#line 257 "rcsy.y"
	{ set_id(); yyval.ids = add_ids(yystack.l_mark[-1].ids, yystack.l_mark[0].str); }
break;
case 64:
#line 260 "rcsy.y"
	{ yyval.idrevs = NULL; }
break;
case 65:
#line 261 "rcsy.y"
	{ yyval.idrevs = yystack.l_mark[0].idrevs; }
break;
case 66:
#line 264 "rcsy.y"
	{ yyval.idrevs = new_idrevs(yystack.l_mark[0].idrev); }
break;
case 67:
#line 265 "rcsy.y"
	{ yyval.idrevs = add_idrevs(yystack.l_mark[-1].idrevs, yystack.l_mark[0].idrev); }
break;
case 68:
#line 268 "rcsy.y"
	{ set_id(); yyval.idrev = new_idrev(yystack.l_mark[-2].str, yystack.l_mark[0].str); }
break;
case 69:
#line 271 "rcsy.y"
	{ yyval.tags = NULL; }
break;
case 70:
#line 272 "rcsy.y"
	{ yyval.tags = yystack.l_mark[0].tags; }
break;
case 71:
#line 275 "rcsy.y"
	{ if(yystack.l_mark[0].tag) yyval.tags = new_tags(yystack.l_mark[0].tag); else yyval.tags = NULL; }
break;
case 72:
#line 276 "rcsy.y"
	{ if(yystack.l_mark[-1].tags && yystack.l_mark[0].tag) yyval.tags = add_tags(yystack.l_mark[-1].tags, yystack.l_mark[0].tag); else if(yystack.l_mark[0].tag) yyval.tags = new_tags(yystack.l_mark[0].tag); else yyval.tags = yystack.l_mark[-1].tags; }
break;
case 73:
#line 279 "rcsy.y"
	{ set_sym(); yyval.tag = new_tag(yystack.l_mark[-2].str, yystack.l_mark[0].str); }
break;
case 74:
#line 285 "rcsy.y"
	{ set_sym(); yyval.tag = NULL; }
break;
#line 1235 "rcs.tab.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
